



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Delphi的String内存结构（够清楚） good</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Delphi的String内存结构（够清楚） good</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 14:37:41 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>变量s的内存结构为<br />（字符串编码）A8 03 （字符宽度）01 00 （引用计数）FF FF FF FF （字符串长度）0A 00 00 00 （实际内容）31 32 33 34 35 36 37 38 39 30 （结束符）00</p>
<p>01~02 字节是代码页，如上面的0x03A8为十进制的936，表示简体中文GBK<br />03~04 字节表示每个字符所占的字节数（ANSI为1，Unicode为2）<br />05~08 字节是该字符串的引用计数<br />09~12 字节是该字符串的字符个数<br />13~?? 字节就是字符串实际的内容了<br />??&nbsp;&nbsp;&nbsp; 最后一个字节是00，字符串的结束符</p>
<p><strong>对于string变量类型s，它实际上是一个指针，指向字符串首个字符的地址，也就是第13个字节</strong></p>
<p>这里需要注意的是，在Delphi 2009以前的版本中是没有描述代码页的4字节的（代码页+字符宽度），而是直接从第05字节开始（引用计数）。</p>
<p>上面的字符串<strong>引用计数为什么会是0xFFFFFFFF呢？因为该字符串是常量，对于常量字符串，引用计数总是-1</strong><br />若有N处相同的字符串常量时，就有N份的拷贝，这样就造成了空间上的浪费，Delphi并未作出优化<br />下面的代码就可以说明问题，两次显示的字符串内存地址不同。</p>
<div>
<ol><li>procedure&nbsp;Foo();</li>
<li>var</li>
<li>s:&nbsp;AnsiString;</li>
<li>begin</li>
<li>s&nbsp;:=&nbsp;'1234567890';</li>
<li>ShowMessage(IntToHex(Integer(@s[1]),&nbsp;8));</li>
<li>end;</li>
<li>procedure&nbsp;TForm1.Button1Click(Sender:&nbsp;TObject);</li>
<li>var</li>
<li>s:&nbsp;AnsiString;</li>
<li>begin</li>
<li>s&nbsp;:=&nbsp;'1234567890';</li>
<li>ShowMessage(IntToHex(Integer(@s[1]),&nbsp;8));</li>
<li>Foo;</li>
<li>end;</li></ol>
</div>
<p>接着看看下面的代码</p>
<div>
<ol><li>var</li>
<li>s:&nbsp;AnsiString;</li>
<li>begin</li>
<li>s&nbsp;:=&nbsp;Caption;</li>
<li>ShowMessage(IntToHex(Integer(@s[1]),&nbsp;8));</li>
<li>end;</li></ol>
</div>
<p>由于没有使用常量字符串，所以引用计数不再是-1<br />（代码页）A8 03 （字符宽度）01 00 （引用计数是1）01 00 00 00 （字符串长度）05 00 00 00 （字符内容）46 6F 72 6D 31 （结束符）00</p>
<p>在知道了string的内存结构后，我们就可以通过代码来观测引用计数的值了</p>
<div>
<ol><ol><li>var</li>
<li>s,&nbsp;s2:&nbsp;AnsiString;</li>
<li>p:&nbsp;^Integer;</li>
<li>begin</li>
<li>s&nbsp;:=&nbsp;Caption;</li>
<li>p&nbsp;:=&nbsp;Pointer(@s[1]); &nbsp;<strong>// 应该是得到s[1]的地址，即第一个字符的地址</strong></li>
<li>Dec(p,&nbsp;2); &nbsp;<strong>// 前移2个单位（8个字节，因为每个^integer类型的数据长度是4）</strong></li>
<li>ShowMessage(IntToStr(p^));&nbsp;&nbsp;//&nbsp;1，引用计数为1</li>
<li>s2&nbsp;:=&nbsp;s;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;//&nbsp;引用计数+1了</li>
<li>ShowMessage(IntToStr(p^));&nbsp;&nbsp;//&nbsp;2，引用计数为2</li>
<li>end;</li></ol></ol>
<p>http://blog.csdn.net/aqtata/article/details/38905387</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49g004q7.html">Laravel - 安装与配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/m960gd49.html">javascript之一切皆为对象2</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqdojgz8.html">慕课网&lowbar;&lowbar;CSS&lowbar;网页图标制作</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q73kkk8.html">How to read a scientific paper</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qypgo2q.html">iOS7中都Bar的透明问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0mmmwq.html">C&num; 委托：把方法组合到一个数组中使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k124lr9.html">转载JQuery 获取设置值，添加元素详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnrl30q.html">bugumongo--ConnectToMongoDB</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnjl2d8.html">android常见错误-Installation error&colon; INSTALL&lowbar;FAILED&lowbar;INSUFFICIENT&lowbar;STORAGE</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okeozl9.html">Querylayer&lpar;查询图层&rpar; - 浅谈</a>
		</li>
						<li><a href="https://www.batexi.com/a/8memyw6q.html">《Java并发编程实战》第二章 线程安全性 读书笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1dvyxq.html">matlab里的nargin</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljryo69.html">Sql万能分页代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me1mnrq.html">一个老鸟发的公司内部整理的 Android 学习路线图</a>
		</li>
						<li><a href="https://www.batexi.com/a/93y50m08.html">kvm虚拟化2-qemu-kvm</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jn6onq.html">javascript 自动填充功能</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj6v009.html">arcgis server缓存路径修改</a>
		</li>
						<li><a href="https://www.batexi.com/a/902v07nq.html">&lpar;转&rpar;javascript方法--bind&lpar;&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vlvz6q.html">js常见兼容</a>
		</li>
						<li><a href="https://www.batexi.com/a/93pvnvg8.html">JAVA Spring JdbcTemplate &lpar; 以 SQLSERVER 为例 &rpar; 的简单使用</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93yo21w8.html">android的事件分发机制理解</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jdz1o8.html">&lbrack;转&rsqb;CentOS 6&period;5安全加固及性能优化</a>
			</li>
						<li><a href="https://www.batexi.com/a/950rekz8.html">&lbrack;转&rsqb;PostgreSQL事务处理机制</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zx5re9.html">纯CSS3实现常见多种相册效果</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzj52e8.html">GPSR协议移植</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1566xq.html">（1）ActivityThread分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv15x51q.html">一个带动画效果的颜色选择对话框控件AnimatedColorPickerDialog</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zmxkx9.html">HTML - HTML Commonly Used Character Entities</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kzz569.html">Ansi&comma;UTF8&comma;Unicode&comma;ASCII编码的差别</a>
			</li>
						<li><a href="https://www.batexi.com/a/950xx768.html">jQuery Easy UI Resizable&lpar;调整大小&rpar;组件</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
